Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.m	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.m	(revision 142)
@@ -421,14 +421,19 @@
 
 // returns YES if menu contains useful items, NO otherwise
-BOOL ICCF_ConsolidateServicesMenu(NSMenu *menu) {
+BOOL ICCF_ConsolidateServicesMenu(NSMenu *menu, NSDictionary *serviceOptions) {
     [menu update]; // doesn't propagate to submenus, so we need to do this first
     NSEnumerator *enumerator = [[menu itemArray] objectEnumerator];
     NSMenuItem *menuItem;
     NSMenu *submenu;
+    NSDictionary *itemOptions = nil;
     BOOL shouldKeepItem = NO, shouldKeepMenu = NO;
 
     while ( (menuItem = [enumerator nextObject]) != nil) {
-        if ( (submenu = [menuItem submenu]) != nil) {
-            shouldKeepItem = ICCF_ConsolidateServicesMenu(submenu);
+        if (serviceOptions != nil)
+            itemOptions = [serviceOptions objectForKey: [menuItem title]];
+        if ([[itemOptions objectForKey: (NSString *)kICServiceHidden] boolValue]) {
+            shouldKeepItem = NO;
+        } else if ( (submenu = [menuItem submenu]) != nil) {
+            shouldKeepItem = ICCF_ConsolidateServicesMenu(submenu, [itemOptions objectForKey: (NSString *)kICServiceSubmenu]);
             if (shouldKeepItem && [submenu numberOfItems] == 1) { // consolidate
                 NSMenuItem *serviceItem = [[submenu itemAtIndex: 0] retain];
@@ -457,5 +462,5 @@
 NSMenuItem *ICCF_ContextualServicesMenuItem() {
     NSMenuItem *servicesItem = ICCF_ServicesMenuItem();
-    if (ICCF_ConsolidateServicesMenu([servicesItem submenu]))
+    if (ICCF_ConsolidateServicesMenu([servicesItem submenu], (NSDictionary *)ICCF_prefs.serviceOptions))
         return servicesItem;
     else
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEConfig.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEConfig.h	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEConfig.h	(revision 142)
@@ -26,4 +26,6 @@
     Boolean servicesInContextualMenu;
     Boolean servicesInMenuBar;
+    CFDictionaryRef serviceOptions;
+    Boolean terminalRequireOptionForSelfDrag;
     Boolean errorSoundEnabled;
     Boolean errorDialogEnabled;
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEController.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEController.h	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEController.h	(revision 142)
@@ -17,4 +17,6 @@
     IBOutlet NSButton *servicesInContextualMenu;
     IBOutlet NSButton *servicesInMenuBar;
+    IBOutlet NSButton *editContextualServices;
+    IBOutlet NSButton *terminalRequireOptionForSelfDrag;
     IBOutlet NSButton *errorSoundEnabled;
     IBOutlet NSButton *errorDialogEnabled;
@@ -30,4 +32,6 @@
 - (IBAction)servicesInContextualMenu:(NSButton *)sender;
 - (IBAction)servicesInMenuBar:(NSButton *)sender;
+- (IBAction)editContextualServices:(NSButton *)sender;
+- (IBAction)terminalRequireOptionForSelfDrag:(NSButton *)sender;
 - (IBAction)errorSoundEnabled:(NSButton *)sender;
 - (IBAction)errorDialogEnabled:(NSButton *)sender;
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEController.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEController.m	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEController.m	(revision 142)
@@ -14,4 +14,5 @@
 #import "ICeCoffEEController.h"
 #import "ICeCoffEEShared.h"
+#import "ICeCoffEEServicePrefController.h"
 
 // Just a handy macro for localized strings from our bundle; unused in this project.
@@ -25,5 +26,5 @@
 + (id)prefPaneHandlerForAPE:(NSBundle*)apeBundle andBundle:(NSBundle*)prefPaneBundle
 {
-    return [[self alloc] initWithAPE:apeBundle andBundle:prefPaneBundle];
+    return [[self alloc] initWithAPE: apeBundle andBundle: prefPaneBundle];
 }
 
@@ -31,7 +32,7 @@
 - (id)initWithAPE:(NSBundle*)apeBundle andBundle:(NSBundle*)prefPaneBundle
 {
-    [self setAPEBundle:apeBundle prefPaneBundle:prefPaneBundle];
+    [self setAPEBundle: apeBundle prefPaneBundle: prefPaneBundle];
     
-    [NSBundle loadNibNamed:@"APE Manager plugin" owner:self];	// load our nib file; it will call our awakeFromNib method
+    [NSBundle loadNibNamed:@"APE Manager plugin" owner:self]; // load our nib file; it will call our awakeFromNib method
     
     return self;
@@ -144,4 +145,13 @@
     [self prefsChanged];
 }
+- (IBAction)editContextualServices:(NSButton *)sender;
+{
+    [[ICeCoffEEServicePrefController alloc] performSelector: @selector(initWithParentWindow:) withObject: [NSApp mainWindow] afterDelay: 0.01];
+}
+- (IBAction)terminalRequireOptionForSelfDrag:(NSButton *)sender;
+{
+    [prefs setBool: [terminalRequireOptionForSelfDrag state] forKey: ICP(TerminalRequireOptionForSelfDrag)];
+    [self prefsChanged];
+}
 - (IBAction)errorSoundEnabled:(NSButton *)sender;
 {
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEKeyEquivalents.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEKeyEquivalents.m	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEKeyEquivalents.m	(revision 142)
@@ -0,0 +1,131 @@
+//
+//  ICeCoffEEKeyEquivalents.m
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Mon Jun 9 2003.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+// Original implementations of these functions are in NSString-NJRExtensions
+// and NSFont-NJRExtensions from Pester.
+
+#import <Carbon/Carbon.h>
+#import <AppKit/AppKit.h>
+
+static NSFont *themeFont(ThemeFontID fontID) {
+    NSFont *themeFont = nil;
+    Str255 pstrFontName;
+    SInt16 fontSize = 0;
+    OSStatus status;
+    // can't simulate algorithmic styles in Cocoa in any case, so here's hoping nothing will be passed back - XXX guess this should at least accommodate the bold system font, but we don't need it
+    status = GetThemeFont(fontID, smSystemScript, pstrFontName, &fontSize, NULL);
+
+    if (status == noErr) {
+        NSString *fontName = (NSString *)CFStringCreateWithPascalString(NULL, pstrFontName, CFStringGetSystemEncoding());
+        themeFont = [NSFont fontWithName: fontName size: fontSize];
+        [fontName release];
+    }
+    if (themeFont == nil) {
+        themeFont = [NSFont systemFontOfSize: fontSize == 0 ? [NSFont systemFontSize] : fontSize];
+    }
+    return themeFont;
+}
+
+static NSString *stringWithCharacter(unichar character) {
+    return [NSString stringWithCharacters: &character length: 1];
+}
+
+static unichar combiningHelpChar[] = {0x003F, 0x20DD};
+
+static NSFont *menuItemCmdKeyFont = nil;
+static NSFont *menuItemFont = nil;
+static NSParagraphStyle *keyEquivParaStyle;
+
+static inline void initialize() {
+    if (menuItemCmdKeyFont != nil) return;
+
+    menuItemCmdKeyFont = [themeFont(kThemeMenuItemCmdKeyFont) retain];
+    menuItemFont = [themeFont(kThemeMenuItemFont) retain];
+
+    NSMutableParagraphStyle *paraStyle = [[NSMutableParagraphStyle alloc] init];
+    [paraStyle setTabStops: [NSArray arrayWithObjects:
+        [[[NSTextTab alloc] initWithType: NSRightTabStopType location: 30] autorelease],
+        [[[NSTextTab alloc] initWithType: NSLeftTabStopType location: 30.01] autorelease],
+        nil]];
+    [paraStyle setLineBreakMode: NSLineBreakByClipping];
+    keyEquivParaStyle = [paraStyle copy];
+    [paraStyle release];
+}
+
+// set tabs here, for ICeCoffEE (not in Pester)
+static NSAttributedString *attributedStringWithFont(NSString *self, NSFont *font) {
+    return [[[NSAttributedString alloc] initWithString: self attributes: [NSDictionary dictionaryWithObjectsAndKeys: font, NSFontAttributeName, keyEquivParaStyle, NSParagraphStyleAttributeName, nil]] autorelease];
+}
+
+static NSString *keyEquivalentString(NSString *self) {
+    if ([self length] != 0) {
+        const char *str = [self UTF8String];
+        unichar keyChar;
+        if (str[1] != '\0') {
+            keyChar = [self characterAtIndex: 0];
+            switch (keyChar) {
+                case NSUpArrowFunctionKey: keyChar = 0x21E1; break;
+                case NSDownArrowFunctionKey: keyChar = 0x21E3; break;
+                case NSLeftArrowFunctionKey: keyChar = 0x21E0; break;
+                case NSRightArrowFunctionKey: keyChar = 0x21E2; break;
+                case NSInsertFunctionKey:
+                    return [NSString stringWithCharacters: combiningHelpChar length: 2];
+                case NSDeleteFunctionKey: keyChar = 0x2326; break;
+                case NSHomeFunctionKey: keyChar = 0x2196; break;
+                case NSEndFunctionKey: keyChar = 0x2198; break;
+                case NSPageUpFunctionKey: keyChar = 0x21DE; break;
+                case NSPageDownFunctionKey: keyChar = 0x21DF; break;
+                case NSClearLineFunctionKey: keyChar = 0x2327; break;
+                default:
+                    if (keyChar >= NSF1FunctionKey && keyChar <= NSF35FunctionKey) {
+                        return [NSString stringWithFormat: @"F%u", keyChar - NSF1FunctionKey + 1];
+                    }
+                    return [NSString stringWithFormat: @"[unknown %lX]", keyChar];
+            }
+        } else if (str[0] >= 'A' && str[0] <= 'Z') {
+            return self;
+        } else if (str[0] >= 'a' && str[0] <= 'z') return [self uppercaseString];
+        else switch (str[0]) {
+            case '\t': keyChar = 0x21e5; break;
+            case '\r': keyChar = 0x21a9; break;
+            case '\e': keyChar = 0x238b; break;
+            case ' ': keyChar = 0x2423; break;
+            case 0x7f: keyChar = 0x232b; break; // delete
+            case 0x03: keyChar = 0x2324; break; // enter
+            case 0x19: keyChar = 0x21e4; break; // backtab
+            case 0: return @"";
+                // case '': keyChar = 0x; break;
+            default: return self; // return [NSString stringWithFormat: @"[huh? %x]", (int)str[0]];
+        }
+            return stringWithCharacter(keyChar);
+    }
+    return self;
+}
+
+NSAttributedString *ICCF_KeyEquivalentAttributedStringWithModifierFlags(NSString *self, unsigned int modifierFlags) {
+    initialize();
+    NSString *keyEquivalentStringNoMask = keyEquivalentString(self);
+    // use tabs here, for ICeCoffEE (not in Pester, at least without better subclassing)
+    NSAttributedString *keyEquivalentAttributedString =
+        attributedStringWithFont(
+          [NSString stringWithFormat: @"\t%@%@%@%@\t%@",
+            (modifierFlags & NSControlKeyMask) ? stringWithCharacter(kControlUnicode) : @"",
+            (modifierFlags & NSAlternateKeyMask) ? stringWithCharacter(kOptionUnicode) : @"",
+            (modifierFlags & NSShiftKeyMask) ? stringWithCharacter(kShiftUnicode) : @"",
+            (modifierFlags & NSCommandKeyMask) ? stringWithCharacter(kCommandUnicode) : @"",
+            keyEquivalentStringNoMask], menuItemCmdKeyFont);
+    unsigned noMaskLength = [keyEquivalentStringNoMask length];
+    if (noMaskLength > 3 || // Fxx
+        (noMaskLength == 1 && [keyEquivalentStringNoMask characterAtIndex: 0] <= 0x7F)) {
+        NSMutableAttributedString *astr = [keyEquivalentAttributedString mutableCopy];
+        [astr setAttributes: [NSDictionary dictionaryWithObject: menuItemFont forKey: NSFontAttributeName] range: NSMakeRange([astr length] - noMaskLength, noMaskLength)];
+        keyEquivalentAttributedString = [[astr copy] autorelease];
+        [astr release];
+    }
+    return keyEquivalentAttributedString;
+}
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingButtonCell.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingButtonCell.h	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingButtonCell.h	(revision 142)
@@ -0,0 +1,16 @@
+//
+//  ICeCoffEENonHighlightingButtonCell.h
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface ICeCoffEENonHighlightingButtonCell : NSButtonCell {
+
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingButtonCell.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingButtonCell.m	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingButtonCell.m	(revision 142)
@@ -0,0 +1,31 @@
+//
+//  ICeCoffEENonHighlightingButtonCell.m
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEENonHighlightingButtonCell.h"
+
+
+@implementation ICeCoffEENonHighlightingButtonCell
+
+- (NSColor *)highlightColorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
+{
+    return [NSColor whiteColor];
+}
+
+- (NSCellStateValue)nextState;
+{
+    switch ([self intValue]) {
+        case NSOnState:
+        case NSMixedState:
+            return NSOffState;
+        case NSOffState:
+            return NSOnState;
+    }
+    return NSMixedState;
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingOutlineView.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingOutlineView.h	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingOutlineView.h	(revision 142)
@@ -0,0 +1,16 @@
+//
+//  ICeCoffEENonHighlightingOutlineView.h
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface ICeCoffEENonHighlightingOutlineView : NSOutlineView {
+
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingOutlineView.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingOutlineView.m	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingOutlineView.m	(revision 142)
@@ -0,0 +1,19 @@
+//
+//  ICeCoffEENonHighlightingOutlineView.m
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEENonHighlightingOutlineView.h"
+
+
+@implementation ICeCoffEENonHighlightingOutlineView
+
+- (void)highlightSelectionInClipRect:(NSRect)rect;
+{
+
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingTextFieldCell.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingTextFieldCell.h	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingTextFieldCell.h	(revision 142)
@@ -0,0 +1,16 @@
+//
+//  ICeCoffEENonHighlightingTextFieldCell.h
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface ICeCoffEENonHighlightingTextFieldCell : NSTextFieldCell {
+
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingTextFieldCell.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingTextFieldCell.m	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEENonHighlightingTextFieldCell.m	(revision 142)
@@ -0,0 +1,19 @@
+//
+//  ICeCoffEENonHighlightingTextFieldCell.m
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEENonHighlightingTextFieldCell.h"
+
+
+@implementation ICeCoffEENonHighlightingTextFieldCell
+
+- (NSColor *)highlightColorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
+{
+    return [NSColor whiteColor];
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.h	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.h	(revision 142)
@@ -0,0 +1,25 @@
+//
+//  ICeCoffEEServicePrefController.h
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface ICeCoffEEServicePrefController : NSWindowController {
+    IBOutlet NSOutlineView *serviceOutline;
+    NSMenu *servicesMenu;
+}
+
+- (id)initWithParentWindow:(NSWindow *)parent;
+
+- (IBAction)showAll:(NSButton *)sender;
+- (IBAction)hideAll:(NSButton *)sender;
+
+- (IBAction)cancel:(NSButton *)sender;
+- (IBAction)saveChanges:(NSButton *)sender;
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEServicePrefController.m	(revision 142)
@@ -0,0 +1,326 @@
+//
+//  ICeCoffEEServicePrefController.m
+//  ICeCoffEE APE
+//
+//  Created by Nicholas Riley on Fri Jun 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "ICeCoffEEShared.h"
+#import "ICeCoffEEServicePrefController.h"
+#import "ICeCoffEENonHighlightingButtonCell.h"
+#import "ICeCoffEENonHighlightingTextFieldCell.h"
+#import <objc/objc.h>
+#import <ApplicationEnhancer/ApplicationEnhancer.h>
+
+static NSNumber *ICCF_SERVICE_SHOWN, *ICCF_SERVICE_HIDDEN, *ICCF_SERVICE_MIXED;
+static NSDictionary *ICCF_SERVICE_OPTION_HIDDEN;
+
+static float ICCF_TableViewCellHeight(NSTableView *tableView) {
+    return ([tableView rowHeight] + [tableView intercellSpacing].height);
+}
+
+static inline NSCellStateValue ICCF_ServiceItemState(NSMenuItem *item) {
+    id state = [item representedObject];
+    return (state == nil) ? NSOnState : [state intValue];
+}
+
+static void ICCF_PropagateServiceStateChange(NSMenu *menu, id state) {
+    NSEnumerator *e = [[menu itemArray] objectEnumerator];
+    NSMenuItem *item;
+    NSMenu *submenu;
+
+    while ( (item = [e nextObject]) != nil) {
+        submenu = [item submenu];
+        if (submenu != nil) {
+            ICCF_PropagateServiceStateChange(submenu, state);
+            [item setRepresentedObject: (state == nil) ? ICCF_SERVICE_SHOWN : state];
+        }
+        [item setRepresentedObject: state];
+    }
+}
+
+static NSCellStateValue ICCF_PropagateServiceState(NSMenuItem *item, NSMenuItem *changedItem) {
+    NSMenu *submenu = [item submenu];
+    if (submenu == nil) return ICCF_ServiceItemState(item);
+
+    if (item == changedItem) ICCF_PropagateServiceStateChange(submenu, [item representedObject]);
+
+    BOOL areOn = NO, areOff = NO;
+    NSEnumerator *e = [[submenu itemArray] objectEnumerator];
+    NSMenuItem *subItem;
+    while ( (subItem = [e nextObject]) != nil) {
+        switch (ICCF_PropagateServiceState(subItem, changedItem)) {
+            case NSOnState: if (!areOff) { areOn = YES; continue; }
+                break;
+            case NSOffState: if (!areOn) { areOff = YES; continue; }
+                break;
+            case NSMixedState:
+                break;
+        }
+        [item setRepresentedObject: ICCF_SERVICE_MIXED];
+        return NSMixedState;
+    }
+    if (areOn) {
+        [item setRepresentedObject: ICCF_SERVICE_SHOWN];
+        return NSOnState;
+    } else {
+        [item setRepresentedObject: ICCF_SERVICE_HIDDEN];
+        return NSOffState;
+    }
+}
+
+static NSMutableDictionary *ICCF_RetainedServiceOptionsDictionary(NSMenu *menu) {
+    NSEnumerator *e = [[menu itemArray] objectEnumerator];
+    NSMenuItem *item;
+    NSMenu *submenu;
+    NSMutableDictionary *dict = nil, *subDict = nil, *submenuDict = nil;
+
+    while ( (item = [e nextObject]) != nil) {
+        submenu = [item submenu];
+        if (ICCF_ServiceItemState(item) == NSOffState) {
+            subDict = [ICCF_SERVICE_OPTION_HIDDEN retain];
+        } else if (submenu != nil) {
+            submenuDict = ICCF_RetainedServiceOptionsDictionary(submenu);
+            if (submenuDict == nil)
+                continue;
+            subDict = [[NSDictionary alloc] initWithObjectsAndKeys: submenuDict, kICServiceSubmenu, nil];
+            [submenuDict release];
+        } else continue;
+        if (dict == nil) {
+            dict = [[NSMutableDictionary alloc] init];
+        }
+        [dict setObject: subDict forKey: [item title]];
+        [subDict release];
+    }
+    return dict;
+}
+
+static void ICCF_RestoreServiceOptionsDictionary(NSMenu *menu, NSDictionary *dict) {
+    NSEnumerator *e = [dict keyEnumerator];
+    NSString *itemTitle;
+    NSDictionary *subDict, *submenuDict;
+    NSMenuItem *item;
+    NSMenu *submenu;
+
+    // XXX handle exceptions
+    while ( (itemTitle = [e nextObject]) != nil) {
+        item = [menu itemWithTitle: itemTitle];
+        if (item == nil) continue;
+        subDict = [dict objectForKey: itemTitle];
+        if ([[subDict objectForKey: (NSString *)kICServiceHidden] boolValue]) {
+            [item setRepresentedObject: ICCF_SERVICE_HIDDEN];
+        }
+        if ( (submenu = [item submenu]) != nil) {
+            submenuDict = [subDict objectForKey: (NSString *)kICServiceSubmenu];
+            if ([submenuDict count] == 0)
+                ICCF_PropagateServiceStateChange(submenu, ICCF_SERVICE_HIDDEN);
+            else
+                ICCF_RestoreServiceOptionsDictionary(submenu, submenuDict);
+        }
+    }
+}
+
+@implementation ICeCoffEEServicePrefController
+
+#pragma mark class initialization
+
++ (void)initialize;
+{
+    ICCF_SERVICE_SHOWN = [[NSNumber alloc] initWithInt: NSOnState];
+    ICCF_SERVICE_HIDDEN = [[NSNumber alloc] initWithInt: NSOffState];
+    ICCF_SERVICE_MIXED = [[NSNumber alloc] initWithInt: NSMixedState];
+    ICCF_SERVICE_OPTION_HIDDEN = [[NSDictionary alloc] initWithObjectsAndKeys: [NSNumber numberWithBool: YES], kICServiceHidden, nil];
+}
+
+#pragma mark initialize-release
+
+- (id)initWithParentWindow:(NSWindow *)parent;
+{
+    if ( (self = [self initWithWindowNibName: @"Select services"])) {
+        NSWindow *window = [self window]; // connect outlets
+        NSButtonCell *checkBoxCell = [[ICeCoffEENonHighlightingButtonCell alloc] init];
+        [checkBoxCell setButtonType: NSSwitchButton];
+        [checkBoxCell setImagePosition: NSImageOnly];
+        [checkBoxCell setAllowsMixedState: YES];
+        [[serviceOutline tableColumnWithIdentifier: @"show"] setDataCell: checkBoxCell];
+        [checkBoxCell release];
+
+        NSTextFieldCell *textFieldCell = [[serviceOutline tableColumnWithIdentifier: @"service"] dataCell];
+        ((struct objc_object *)textFieldCell)->isa = [ICeCoffEENonHighlightingTextFieldCell class];
+
+        textFieldCell = [[serviceOutline tableColumnWithIdentifier: @"key"] dataCell];
+        ((struct objc_object *)textFieldCell)->isa = [ICeCoffEENonHighlightingTextFieldCell class];
+
+        [window setResizeIncrements: NSMakeSize(1, ICCF_TableViewCellHeight(serviceOutline))];
+        if (parent != nil) {
+            [NSApp beginSheet: window modalForWindow: parent modalDelegate: self didEndSelector: nil contextInfo: nil];
+        } else {
+            [window center];
+            [window makeKeyAndOrderFront: nil];
+        }
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [servicesMenu release];
+    [super dealloc];
+}
+
+#pragma mark actions
+
+- (IBAction)showAll:(NSButton *)sender;
+{
+    ICCF_PropagateServiceStateChange(servicesMenu, nil);
+    [serviceOutline reloadData];
+}
+
+- (IBAction)hideAll:(NSButton *)sender;
+{
+    ICCF_PropagateServiceStateChange(servicesMenu, ICCF_SERVICE_HIDDEN);
+    [serviceOutline reloadData];
+}
+
+- (void)closeWithReturnCode:(int)returnCode;
+{
+    if ([[self window] isSheet]) {
+        [NSApp endSheet: [self window] returnCode: NSRunAbortedResponse];
+    }
+    [self close];
+}
+
+- (IBAction)cancel:(NSButton *)sender;
+{
+    [self closeWithReturnCode: NSRunAbortedResponse];
+}
+
+- (IBAction)saveChanges:(NSButton *)sender;
+{
+    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    NSMutableDictionary *icDefaults = [[defaults persistentDomainForName: (NSString *)kICBundleIdentifier] mutableCopy];
+    NSDictionary *serviceOptions = ICCF_RetainedServiceOptionsDictionary(servicesMenu);
+    if (serviceOptions != nil) {
+        [icDefaults setObject: serviceOptions forKey: (NSString *)kICServiceOptions];
+        [serviceOptions release];
+    } else {
+        [icDefaults removeObjectForKey: (NSString *)kICServiceOptions];
+    }
+    [defaults setPersistentDomain: icDefaults forName: (NSString *)kICBundleIdentifier];
+    [defaults synchronize];
+    APEMessageBroadcast(kICBundleIdentifier, kICPreferencesChanged, NULL);
+    [icDefaults release];
+    [self closeWithReturnCode: NSRunStoppedResponse];
+}
+
+@end
+
+@implementation ICeCoffEEServicePrefController (NSOutlineViewDataSource)
+
+- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item;
+{
+    if (servicesMenu == nil) {
+        servicesMenu = [[NSMenu alloc] initWithTitle: @""];
+        [[NSApplication sharedApplication] setServicesMenu: servicesMenu];
+        [servicesMenu update];
+        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+        NSDictionary *icDefaults = [defaults persistentDomainForName: (NSString *)kICBundleIdentifier];
+        NSDictionary *serviceOptions = [icDefaults objectForKey: (NSString *)kICServiceOptions];
+        ICCF_RestoreServiceOptionsDictionary(servicesMenu, serviceOptions);
+    }
+    return [(item == nil ? servicesMenu : [item submenu]) numberOfItems];
+}
+
+- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item;
+{
+    return (item == nil ? YES : [item submenu] != nil);
+}
+
+- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item;
+{
+    return [(item == nil ? servicesMenu : [item submenu]) itemAtIndex: index];
+}
+
+NSAttributedString *ICCF_KeyEquivalentAttributedStringWithModifierFlags(NSString *self, unsigned int modifierFlags);
+
+- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;
+{
+    if ([[tableColumn identifier] isEqualToString: @"service"]) {
+        return [item title];
+    } else if ([[tableColumn identifier] isEqualToString: @"show"]) {
+        id state = [item representedObject];
+        if ([item submenu] != nil && state == nil) {
+            return [NSNumber numberWithInt: ICCF_PropagateServiceState(item, nil)];
+        }
+        return (state == nil) ? ICCF_SERVICE_SHOWN : state;
+    } else if ([[tableColumn identifier] isEqualToString: @"key"]) {
+        NSString *equivalent = [item keyEquivalent];
+        if (equivalent == nil || [equivalent length] != 1) return nil;
+        // XXX Inconsistency between Cocoa and Carbon: always command-shift in Carbon, not in Cocoa.  Since we only patch Cocoa for the moment, keep as is.
+        return ICCF_KeyEquivalentAttributedStringWithModifierFlags(equivalent, [item keyEquivalentModifierMask] | ([[NSCharacterSet uppercaseLetterCharacterSet] characterIsMember: [equivalent characterAtIndex: 0]] ? NSShiftKeyMask : 0));
+    }
+    return nil;
+}
+
+- (void)outlineView:(NSOutlineView *)outlineView setObjectValue:(id)object forTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;
+{
+    if ([[tableColumn identifier] isEqualToString: @"show"]) {
+        [item setRepresentedObject: [object boolValue] ? nil : ICCF_SERVICE_HIDDEN];
+        
+        NSMenu *submenu = [item menu];
+        if (submenu == servicesMenu) {
+            ICCF_PropagateServiceState(item, item);
+        } else {
+            NSMenu *supermenu;
+            while ( (supermenu = [submenu supermenu]) != servicesMenu) {
+                submenu = supermenu;
+            }
+            ICCF_PropagateServiceState([supermenu itemAtIndex: [supermenu indexOfItemWithSubmenu: submenu]], item);
+        }
+        [outlineView reloadData];
+    }
+}
+
+@end
+
+@implementation ICeCoffEEServicePrefController (NSWindowDelegate)
+
+- (NSRect)windowWillUseStandardFrame:(NSWindow *)sender defaultFrame:(NSRect)defaultFrame;
+{
+    NSWindow *window = [serviceOutline window];
+    NSRect frame = [window frame];
+    NSScrollView *scrollView = [serviceOutline enclosingScrollView];
+    float displayedHeight = [[scrollView contentView] bounds].size.height;
+    float heightChange = [[scrollView documentView] bounds].size.height - displayedHeight;
+    float heightExcess;
+
+    if (heightChange >= 0 && heightChange <= 1) {
+        // either the window is already optimal size, or it's too big
+        float rowHeight = ICCF_TableViewCellHeight(serviceOutline);
+        heightChange = (rowHeight * [serviceOutline numberOfRows]) - displayedHeight;
+    }
+
+    frame.size.height += heightChange;
+
+    if ( (heightExcess = [window minSize].height - frame.size.height) > 1 ||
+         (heightExcess = [window maxSize].height - frame.size.height) < 1) {
+        heightChange += heightExcess;
+        frame.size.height += heightExcess;
+    }
+
+    frame.origin.y -= heightChange;
+
+    return frame;
+}
+
+@end
+
+@implementation ICeCoffEEServicePrefController (NSWindowNotifications)
+
+- (void)windowWillClose:(NSNotification *)notification;
+{
+    [self autorelease];
+}
+
+@end
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h	(revision 142)
@@ -39,6 +39,13 @@
 extern const CFStringRef kICServicesInContextualMenu; // CFNumber (Boolean)
 extern const CFStringRef kICServicesInMenuBar; // CFNumber (Boolean)
+extern const CFStringRef kICServiceOptions; // CFDictionary
+extern const CFStringRef kICTerminalRequireOptionForSelfDrag; // CFNumber (Boolean)
 extern const CFStringRef kICErrorSoundEnabled; // CFNumber (Boolean)
 extern const CFStringRef kICErrorDialogEnabled; // CFNumber (Boolean)
+
+// kICServiceOptions dictionary keys
+extern const CFStringRef kICServiceHidden; // CFNumber (Boolean)
+extern const CFStringRef kICServiceShortcut; // reserved for future use
+extern const CFStringRef kICServiceSubmenu; // CFDictionary
 
 // APEBundleMessages
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.m	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.m	(revision 142)
@@ -25,6 +25,13 @@
 const CFStringRef kICServicesInContextualMenu = (CFStringRef)@"ICServicesInContextualMenu"; // CFNumber (bool)
 const CFStringRef kICServicesInMenuBar = (CFStringRef)@"ICServicesInMenuBar"; // CFNumber (bool)
+const CFStringRef kICServiceOptions = (CFStringRef)@"ICServiceOptions"; // CFDictionary
+const CFStringRef kICTerminalRequireOptionForSelfDrag = (CFStringRef)@"ICTerminalRequireOptionForSelfDrag"; // CFNumber (Boolean)
 const CFStringRef kICErrorSoundEnabled = (CFStringRef)@"ICErrorSoundEnabled"; // CFNumber (bool)
 const CFStringRef kICErrorDialogEnabled = (CFStringRef)@"ICErrorDialogEnabled"; // CFNumber (bool)
+
+// kICServiceOptions dictionary keys
+const CFStringRef kICServiceSubmenu = (CFStringRef)@"ICServiceSubmenu"; // CFDictionary
+const CFStringRef kICServiceHidden = (CFStringRef)@"ICServiceHidden"; // CFNumber (Boolean)
+const CFStringRef kICServiceShortcut = (CFStringRef)@"ICServiceShortcut"; // reserved for future use
 
 // APEBundleMessages
